/*
 * tools.h: Various tools
 *
 * See the main source file 'vdr.c' for copyright information and
 * how to reach the author.
 *
 * $Id: tools.h 2.4 2009/12/23 15:14:39 kls Exp $
 */

#ifndef __TOOLS_H
#define __TOOLS_H

//#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
//#include <float.h>
//#include <iconv.h>
//#include <math.h>
//#include <poll.h>
//#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
//#include <stdlib.h>
#include <string.h>
//#include <syslog.h>
#include <sys/stat.h>
#include <sys/types.h>

typedef unsigned char uchar;

#define esyslog(a...) void( fprintf(stderr, a) && fprintf(stderr, "\n") )
#define isyslog(a...) void( fprintf(stderr, a) && fprintf(stderr, "\n") )
#define dsyslog(a...) void( fprintf(stderr, a) && fprintf(stderr, "\n") )

#ifndef __STL_CONFIG_H // in case some plugin needs to use the STL
template<class T> inline T min(T a, T b) { return a <= b ? a : b; }
template<class T> inline T max(T a, T b) { return a >= b ? a : b; }
template<class T> inline int sgn(T a) { return a < 0 ? -1 : a > 0 ? 1 : 0; }
template<class T> inline void swap(T &a, T &b) { T t = a; a = b; b = t; }
#endif

#define MALLOC(type, size)  (type *)malloc(sizeof(type) * (size))

ssize_t safe_read(int filedes, void *buffer, size_t size);


#endif //__TOOLS_H
